<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>30.10</title>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
</head>

<body>
    <div class="container mt-5">
        <form id="login-form">
            <div class="form-group">
                <label for="exampleInputEmail1">Email address</label>
                <input type="email" class="form-control" id="exampleInputEmail1" aria-describedby="emailHelp">
                <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                    else.</small>
            </div>
            <div class="form-group">
                <label for="exampleInputPassword1">Password</label>
                <input type="password" class="form-control" id="exampleInputPassword1">
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    </div>

    <script>
        'use strict';
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_STATUS_CREATED = 201;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
        var gLoginForm = document.getElementById("login-form");

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        gLoginForm.addEventListener("submit", (paramEvent) => {
            paramEvent.preventDefault();

            //Thu thập dữ liệu
            var vEmailInput = document.getElementById("exampleInputEmail1");
            var vPasswordInput = document.getElementById("exampleInputPassword1");

            var vParamLogin = {
                email: "",
                password: ""
            }

            vParamLogin.email = vEmailInput.value;
            vParamLogin.password = vPasswordInput.value;

            // Tracing bước 1
            console.log(vParamLogin);

            //Validate dữ liệu
            var vValidate = validateInput(vParamLogin.email, vParamLogin.password);

            if (vValidate) {
                //Gửi dữ liệu tới server
                const vParams = new URLSearchParams({
                    email: vParamLogin.email,
                    password: vParamLogin.password,
                });

                // create a request
                var vXmlHttpLogin = new XMLHttpRequest();
                vXmlHttpLogin.open("GET", gBASE_URL + "?" + vParams.toString(), true);
                vXmlHttpLogin.send();
                vXmlHttpLogin.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                            var vLoginInfo = vXmlHttpLogin.responseText;
                            //Tracing bước 4
                            console.log(vLoginInfo);
                        }
                    }
            }

        })

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function validateInput(paramEmail, paramPassword) {
            if (!paramEmail.includes("@")) {
                alert("Email không đúng định dạng");
                return false;
            }

            if (paramPassword === "") {
                alert("Password không được để trống");
                return false;
            }

            return true;
        }


    </script>
</body>

</html>